package com.totopia.server.modules.user.entity;

import com.totopia.server.commons.data.entity.UserDateAuditEntity;
import com.totopia.server.modules.user.type.ProcessingStatus;
import lombok.*;
import lombok.experimental.SuperBuilder;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

@Entity(name = "deposit")
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@Getter
@Setter
@ToString
@Data
public class DepositEntity extends UserDateAuditEntity implements Serializable {

    @Id
    @GeneratedValue(generator = "deposit_generator")
    @SequenceGenerator(name = "deposit_generator", sequenceName = "deposit_sequence", initialValue = 1)
    private Long id;

    @Column(name = "amount_of_money", nullable = false)
    private Integer amountOfMoney;

    @Column(name = "deposit_user", nullable = false)
    private Long depositUser;

    @Column(name = "confirm_user", nullable = false)
    private Long confirmUser;

    @Column(name = "bank_account", nullable = false)
    private Long bankAccount;

    @Enumerated(EnumType.STRING)
    @Column(name = "status", length = 60)
    private ProcessingStatus status;

}
