package com.totopia.server.modules.user.repository;

import com.totopia.server.modules.user.entity.BankAccountEntity;
import com.totopia.server.modules.user.entity.DepositEntity;
import com.totopia.server.modules.user.entity.UserEntity;
import com.totopia.server.modules.user.type.ProcessingStatus;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.List;

import static org.junit.Assert.*;

@Ignore
@RunWith(SpringRunner.class)
@SpringBootTest
public class DepositRepositoryTest {

    @Autowired
    private UserRepository userRepository;
    @Autowired
    private BankAccountRepository bankAccountRepository;
    @Autowired
    private DepositRepository depositRepository;

    List<UserEntity> users;
    List<BankAccountEntity> accounts;

    @Before
    public void setUp() throws Exception {
        users = this.userRepository.findAll();
        accounts = this.bankAccountRepository.findAll();

    }

    @Test
    public void insertTest() throws Exception {
        DepositEntity en = DepositEntity.builder()
                .amountOfMoney(10000)
                .bankAccount(accounts.get(2).getId())
                .confirmUser(accounts.get(0).getId())
                .depositUser(accounts.get(2).getId())
                .status(ProcessingStatus.PROCESSING_HOLD)
                .build();

//        DepositEntity entity = new DepositEntity();
//
//        entity.setAmountOfMoney(2000000);
//        entity.setBankAccount(accounts.get(1).getId());
//        entity.setConfirmUser(accounts.get(0).getId());
//        entity.setDepositUser(accounts.get(1).getId());
//        entity.setStatus(ProcessingStatus.PROCESSING_WAITING);
//        entity.setCreatedBy(accounts.get(1).getId());
//        entity.setUpdatedBy(accounts.get(1).getId());

        this.depositRepository.save(en);
    }

    @Test
    public void updateTest() throws Exception {
        DepositEntity entity = this.depositRepository.findById(1L).orElse(null);
        entity.setStatus(ProcessingStatus.PROCESSING_COMPLETE);
        this.depositRepository.save(entity);
        assertEquals(entity.getDepositUser().longValue(), 2L);
    }
}