package com.totopia.server.modules.user.repository;

import com.totopia.server.modules.user.entity.BankAccountEntity;
import com.totopia.server.modules.user.entity.UserEntity;
import com.totopia.server.modules.user.entity.WithdrawalEntity;
import com.totopia.server.modules.user.type.ProcessingStatus;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.List;

import static org.junit.Assert.*;

@RunWith(SpringRunner.class)
@SpringBootTest
public class WithdrawalRepositoryTest {

    @Autowired
    private UserRepository userRepository;
    @Autowired
    private BankAccountRepository bankAccountRepository;
    @Autowired
    private WithdrawalRepository withdrawalRepository;

    List<UserEntity> users;
    List<BankAccountEntity> accounts;

    @Before
    public void setUp() throws Exception {
        users = this.userRepository.findAll();
        accounts = this.bankAccountRepository.findAll();
    }

    @Test
    public void insertTest() throws Exception {
        WithdrawalEntity en = WithdrawalEntity.builder()
                .amountOfMoney(10000)
                .bankAccount(accounts.get(2).getId())
                .confirmUser(accounts.get(0).getId())
                .withdrawalUser(accounts.get(2).getId())
                .status(ProcessingStatus.PROCESSING_WAITING)
                .build();

        this.withdrawalRepository.save(en);
    }
}